## p40-container

Project to generate container running `p40-lli-devices` software stack for
different user cases `fedd`, `git`, `minidaq2`, `mygit`, `rep`, `stable`
and `unstable`.

Containers are instantiated via [podman](https://podman.io/) and images
managed by [buildah](https://buildah.io/) and
[skopeo](https://github.com/containers/skopeo).
Since `podman` is  *daemonless* and *rootless*, containers can be managed
by any user.

This approach is quite flexible since it allows to the run the
`p40-lli-devices` software stack on a naked pc-server, or on an EB-server
without disturbing its installation. It allows also to work with different
software versions or different user cases at the same time.

#### case `fedd`:

* Version of the software stack used during the production of tha board
  at the fedd company.
* PCIe driver and tools are installed from rpms.
* `p40-lli` and `conda` are installed from rpms.
* The conda environment `p40_lli_devices_py37` contains python3
  and third party modules required by `p40-lli-devices` software.
* The source of `p40-lli-devices` is from GitLab locked at the commit
  used in production.
* Reference files are updated to the latest version, at start-up.
* Usual `pcie40` commands are in `/root/bin`.
* The `/root` directory contains:

        /root/bin
        /root/p40-lli-devices

#### case `git`:

* Full installation bases on source of `p40-lli` and `p40-lli-devices`
  project coming from GitLab repository.
* Local installation of conda in which the environment `base` contains
  python3 and third party modules.
* PCIe driver and tools are installed from rpms.
* Usual `pcie40` commands are in `/root/bin`.
* The `/root` directory contains:

        /root/bin
        /root/miniconda3
        /root/p40-lli
        /root/p40-lli-devices

#### case `minidaq2`:
* To run with pcie40 board v1 used in the so called `minidaq2` setup.
* The software stack is installed from rpms coming from the `stable`
  repositories.
* The conda environment `p40_lli_devices_env` contains `python 2.7`
  and third party modules required by `p40-lli-devices` software.
* The container can also be linked to a `p40-lli-devices` projet stored
  on the host. In that case the branch has to be `minidaq2-master`.

#### case `mygit`:

* Similar to the user case `git` but the source of the `p40-lli-devices`
  is on the host not in the container. Therefore the user can modify
  the source and push changes in the GitLab repository.

#### case  `rep`

* Run tools useful to analyze data generated by the `p40-lli-devices` tools.

#### case `stable`

* The software stack is installed from rpms coming from the `stable`
  repository. The user can select the version of rpms.

#### case `unstable`

* The software stack is installed from rpms coming from the `unstable`
  repository. RPMs are the latest available.

### Documentation

* [Install](docs/INSTALL.md)
* [How to build container images](docs/howto_build_container_image.md)
* [How to build the rpm](docs/howto_build_rpm.md)
* [How to run a user case](docs/howto_run_user_case.md)
* [How to mount a local directory in the container](docs/howto_mount_directory.md)
* [How to list existing images](docs/howto_list_existing_images.md)

### Authors

* R. Le Gac

### Contributors

### License

Copyright CERN for the benefit of the LHCb Collaboration.
Distributed under the terms of the GNU
[General Public Licence V3](https://www.gnu.org/licenses/gpl.html).
`p40-container` is free and open source software.

